/*
 *
 */
#declare H_stele = 3.25;		// hauteur du fond
#declare E_stele = 0.55;		// epaisseur
#declare L_stele = 2.35;		// demi-largeur

#declare Gravure_Stele = object
{
#local Epp = 0.08;
union	{
        text { ttf "Fonts/FreeSansBold.ttf" , "Mask all the NMIs!", Epp, 0
                        translate <0.0, 1.05, 0> }
        text { ttf "Fonts/FreeSansBold.ttf", "...be a warrior...", Epp, 0
                        translate <0.10, 0.05, 0> }
	}
scale <-0.37, 0.57, 0.65>
// texture { T_Grnt10 scale 0.95 }
texture { T_Copper_3E }
translate <2.04, 1.84, 0.02>
}

#declare Stele_fond = object
{
difference {
	union {
		box { <-L_stele, 0, 0.01>, <L_stele, H_stele, E_stele> }
		#local LX = L_stele - 0.20;
		#local HX = H_stele - 0.04;
		#local RX = 0.10;
		cylinder { <LX, HX, E_stele/2>,
				<-LX, HX, E_stele/2>, RX }
		sphere { <-LX, HX, E_stele/2>, RX }
		sphere { < LX, HX, E_stele/2>, RX }
		}

	#local RK = E_stele / 7;
	cylinder { <-L_stele, 0,  0.01>, <-L_stele, 5,  0.01>, RK }
	cylinder { <-L_stele, 0,  E_stele>, <-L_stele, 5,  E_stele>, RK }

	cylinder { < L_stele, 0, -0.01>, < L_stele, 5, -0.01>, RK }
	cylinder { < L_stele, 0, E_stele>, < L_stele, 5, E_stele>, RK }
	}

texture { T_Grnt10 scale 1.55 }

}

#declare Stele_fond_gravure = object
{
// XXX difference	{
union	{
	object { Stele_fond }
	object { Gravure_Stele  translate (E_stele-0.009)*z }
	}
}

/*		---			*/
#declare Stele_base = object
{
#local Dx = 0.55;
#local Zd = E_stele+1.40;
#local H2 = H_trottoir / 2;
difference {
	box { <-(L_stele+Dx), 0, 0>, <L_stele+Dx, H_trottoir, Zd> }
	cylinder { <-(L_stele+Dx), H2, Zd>, <-(L_stele+Dx), 1, Zd>, 0.333 }
	// XXX torus ici ?
	cylinder { < (L_stele+Dx), H2, Zd>, < (L_stele+Dx), 1, Zd>, 0.333 }
	// XXX torus ici ?
	}

texture { T_Stone31 scale 0.19 }
}
/*		---			*/

#declare Stele_un_coin = object
{
#local HC = H_stele - 0.42;
#local R_coin = 0.17;

merge {
	/* PARTIE BASSE */
	difference {
		merge	{
			cylinder { <0, 0, 0>, <0, 0.40, 0>, R_coin*2 }
			cone { <0, 0.40, 0>, R_coin*2, <0, 0.48, 0>, R_coin }
			}

		#for (foo, 0, 360, 72/2)
		  #local dX = R_coin * 2.20 * sin(radians(foo));
		  #local dZ = R_coin * 2.20 * cos(radians(foo));
		  cylinder { <0, -1, 0>, <0, 0.80, 0>, 0.055 translate <dX, 0, dZ> }
		#end
		}

	/* PARTIE HAUTE */
	cylinder { <0, 0, 0>, <0, HC, 0>, R_coin }
	sphere { 0, R_coin scale <1, 0.666, 1> translate y*HC }

	}
}

#declare Stele_les_coins = object
{
union	{
	#local EX = L_stele * 1.07;
	object { Stele_un_coin translate <-EX, 0, E_stele*1.99> }
	object { Stele_un_coin translate < EX, 0, E_stele*2.01> }
	}
texture { T_Grnt12 scale 1.50 }
}

/*		truc etrange */

#declare Stele_A_milieu = object
{
union	{
	#local HSA = 1.95;
	#local HSB = HSA - 0.45;

	box      { <-1.10, 0, -0.25>, <1.15, 0.10, 0.25> }
	cylinder { < 0, 0,  0>, <0, HSA, 0>, 0.09       }
	sphere   { 0, 0.09  scale <1, 5, 1> translate y*HSA }
	cylinder { <-0.80, 0,  0>, <0, HSB, 0>, 0.045       }
	cylinder { < 0.80, 0,  0>, <0, HSB, 0>, 0.045       }
	}

texture {
	pigment { color Gray90 }
	// finish { specular 0.80 }
	finish { LOL_FINISH }
	}
}

#declare Stele_A = object
{
union	{
	object { Stele_base 					}
	object { Stele_fond_gravure 				}
	object { Stele_les_coins 				}
	object { Stele_A_milieu translate <0, H_trottoir, 1.66> }
	}
}

/* ------------------- variant ------------------------- */

#declare Stele_B_bollard = object
{
union	{
	/* PARTIE BASSE */
	difference {
		union {
			cylinder { <0, 0, 0>, <0, 0.45, 0>, 0.23 }
			cone { <0, 0.45, 0>, 0.23, <0, 0.51, 0>, 0.14 }
			}

		#for (foo, 0, 360, 72/2)
			#local dX = 0.266 * sin(radians(foo));
			#local dZ = 0.266 * cos(radians(foo));
			cylinder { <0, -1, 0>, <0, 0.80, 0>, 0.05 translate <dX, 0, dZ> }
		 #end
		}

	/* PARTIE HAUTE */
	difference {
		cylinder { <0, 0, 0>, <0, 1.15, 0>, 0.14 }
		#for (foo, 0.60, 1.05, 0.07)
			torus { 0.168, 0.03 translate y*foo }
		#end
		}
	sphere { 0, 0.14 scale <1, 0.717, 1> translate y*1.15 }
	}
scale <1.15, 1, 0.95>
texture {
	pigment { color Turquoise }
	normal { bumps 0.58 scale 0.11 }
	finish { phong PHONG specular SPECULAR  }
	}
}

#declare Stele_B = object
{
union	{
	object { Stele_base 				}
	object { Stele_fond_gravure 			}
	object { Stele_les_coins 			}
	object { Stele_B_bollard translate  <-1.32, H_trottoir, 1.46> }
	object { Stele_B_bollard translate  < 1.34, H_trottoir, 1.46> }
	}
}

